#!/usr/bin/env python
import os, sys, glob, re, subprocess, base64, MySQLdb, shutil, time, optparse
from random import randrange
from subprocess import Popen

# Visit http://movie-info.org/contribute for more information

__VERSION__ = "0.6.1b"

lineDict = {}

filename = "MovieInfo-%s.log" % str(randrange(1,100)).zfill(3)

fp = open(filename,"w+")

print "Opening %s." % filename

def sendError(message):
	print "%s Exiting..." % message
	sys.exit(1)

def appendLine(key,value):
	global lineDict
	lineDict[key] = value
	return 0

def writeLine():
	global lineDict, fp
	line = ""
	for l in lineDict:
		line += "%s:%s;" % (l,lineDict[l])
	
	fp.write(line+"\n")
	lineDict = {}
	
def getMetaData(videoFile,origcwd):
	
	cwd = os.getcwd()
	os.chdir(origcwd)
	
	if os.name == "nt":
		#miDir = origcwd+"\\"+"\\".join(sys.argv[0].split("\\")[0:-1])
		#cmd = "%s\\MediaInfo.exe" % miDir		
		cmd = "MediaInfo.exe"
		#print cmd
		if not os.path.exists(cmd):
			sendError("Please install MediaInfo.exe (CLI).")
		
	else:
		cmd = "mediainfo"
		checkcmd = Popen(cmd,shell=True,stdout=subprocess.PIPE)
		checkcmd.wait()
		
		if checkcmd.returncode == 32512:
			sendError("Please install mediainfo (and place in PATH directory).")

	# Get info from MediaInfo
	cmd = cmd.replace(" "," ")
	micmd = "%s \"%s\"" % (cmd,videoFile)
	#print os.getcwd()
	print micmd
	mi = Popen(micmd,shell=True,stdout=subprocess.PIPE)
	start = time.time()
	output = []
	while mi.poll() != 0 and output == []:
		#print "MediaInfo still going."
		time.sleep(3)
		output = mi.stdout.read().split("\n")
		if time.time()-start >= 180:
			print "Gave up on MediaInfo"
			if sys.version >= '2.6':
				mi.terminate()
			break
				
	#os.chdir(cwd)
	acodec = "N/A"
	resolution = "N/A"
	framerate = "N/A"
	#output = mi.stdout.read().split("\n")
	miDict = {}
	for o in output:
		o = o.rstrip("\r")
		o = o.split(":",1)
		#print o
		if len(o) == 1:
			# General, Video, Audio #1, Audio #2 etc
			mediaType = o[0]
			miDict[mediaType] = {}
		elif len(o) == 2:
			key = o[0].strip()
			value = o[1].strip()
			miDict[mediaType][key] = value
		else:
			continue
	
	if miDict.has_key("Video"):
		if miDict["Video"].has_key("Width") and miDict["Video"].has_key("Height"):
			resolution = "%sx%s" % (miDict["Video"]["Width"].split(" pixels")[0].replace(" ",""),miDict["Video"]["Height"].split(" pixels")[0].replace(" ",""))
			#print resolution
		else:
			resolution = "N/A"
		if miDict["Video"].has_key("Frame rate"):
			framerate = miDict["Video"]["Frame rate"].split()[0]
	else:
		resolution = "N/A"
		framerate = "N/A"
		
	if miDict.has_key("Audio"):
		defaultAudioKey = "Audio"
		
	# For multi-audio releases
	elif miDict.has_key("Audio #1"):
		defaultAudioKey = "Audio #1"
	
	# Its hopeless!
	else:
		acodec = "N/A"
		defaultAudioKey = 0
		
	if defaultAudioKey:
		if miDict[defaultAudioKey].has_key("Format"):
			acodec = miDict[defaultAudioKey]["Format"]
			if acodec == "AC-3":
				acodec = "AC3"
			if miDict[defaultAudioKey].has_key("Format profile"):
				if acodec == "MPEG Audio" and miDict[defaultAudioKey]["Format profile"] == "Layer 3":
					acodec = "MP3"
			#print acodec
		else:
			acodec = "N/A"
	"""
	else:
		print "DEBUG: %s" % os.getcwd()
		print "DEBUG: %s" % micmd
		sendError("Please report this error along with the DEBUG code above to an operator.")
	"""
	
	return resolution,framerate,acodec
def uploadData():
	global filename
	print filename
	print "Connecting To MySQL..."
	db = MySQLdb.connect(host="movieinfo.ath.cx",user="uploader",passwd="writeonly",db="movieinfo")
	cursor = db.cursor()
	
	print "Uploading data..."
	fp = open(filename,"r")
	lines = fp.read().split("\n")
	for l in lines:
		#print l
		l = l.strip("\r")
		infoDict = {}
		for data in l.split(";"):
			if data != "":
				data = data.split(":",1)
				#print data
				key = data[0]
				value = data[1]
				infoDict[key] = value.replace("\'","")
			
		#print infoDict
		if l == lines[0].strip("\r"):
			contributor = infoDict["contributor"]
			version = infoDict["__VERSION__"]
			
		if l != lines[0].strip("\r") and l.strip() != "":
			if infoDict["fc"] == "N/A":
				infoDict["fc"] = "0"
			if infoDict["rarsize"] == "N/A":
				infoDict["rarsize"] = "0"
			if not infoDict.has_key("imdbIDs"):
				infoDict["imdbIDs"] = "NONE"
				infoDict["nfo_filenames"] = "NONE"
				infoDict["nfos"] = ""
				
			query = "INSERT INTO tempinfo\
			(rlsname,grp,fc,rarsize,totalsize,source,vcodec,resolution,framerate,videofile,acodec,\
			imdbid,nfo_filename,nfo,contributor,appversion)\
			VALUES ('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')" %\
			(infoDict["rlsname"],infoDict["grp"],infoDict["fc"],infoDict["rarsize"],infoDict["totalsize"],
			infoDict["source"],infoDict["vcodec"],infoDict["resolution"],infoDict["framerate"],
			infoDict["videofile"],infoDict["acodec"],infoDict["imdbIDs"],infoDict["nfo_filenames"],
			infoDict["nfos"],contributor,version)
			#print infoDict["rarsize"]
			
			cursor.execute(query)
	
	print "Data uploaded successfully."
	
def getSource(rlsname):
	if 'dvdrip' in rlsname.lower() or '.dvd.' in rlsname.lower() or 'dvdivx' in rlsname.lower():
		source = "DVDRip"
	elif 'hddvd' in rlsname.lower():
		source = "HDDVD"
	elif 'bluray' in rlsname.lower() or 'bdrip' in rlsname.lower():
		source = "BluRay"
	elif 'hdtv' in rlsname.lower():
		source = "HDTV"
	else:
		source = "UNKNOWN"
		
	return source
	
def getCodec(rlsname):
	if 'xvid' in rlsname.lower() or 'dvdxvid' in rlsname.lower():
		codec = 'XviD'
	elif 'divx' in rlsname.lower() or 'dvdivx' in rlsname.lower():
		codec = 'DivX'
	elif 'x264' in rlsname.lower():
		codec = 'x264'
	else:
		codec = "UNKNOWN"
		
	return codec
	
def main(options,args):
	global fp
	
	db = MySQLdb.connect(host="movieinfo.ath.cx",user="uploader",passwd="writeonly",db="movieinfo")
	
	globals()["origcwd"] = os.getcwd()
	
	if os.name == "nt":
		globals()["slash"] = "\\"
	else:
		globals()["slash"] = "/"
		
	for a in args:
		#fp.close()
		#fp = open(filename,"a")
		if options.singleDir:
			path = a.rstrip(slash).rsplit(slash,1)
			rlsnameList = [path[-1]]
			path = path[0]
			#print rlsnameList
			#print path		
			try:
				os.chdir(path)
			except:
				sendError("Can't enter %s." % path)
		else:	
			path = a.rstrip(slash)
		
			try:
				os.chdir(path)
			except:
				sendError("Can't enter %s." % path)
			
			rlsnameList = glob.glob("*/")
	
	
		for dirname in rlsnameList:
			rlsname = dirname.strip(slash).replace("\'","")
			print rlsname
			grp = rlsname.split("-")[-1]
		
			# Check if non-scene (XviD)
			if re.search("-(DEVISE|KINGBEN|AXXO|REPo|Shoo|CycLOPS|KamuiX|VH|iDRiSSi|ApReCiAte|porphyria|iNT|M14CH0|Zookeeper525|B0DZi0|OLJEPANNA|MKR-RFM|GX|qNs|UnSeeN|MeR-DeR|RipperMortis|MF|PJCTW|NDRT|Status-X|AssMaster|C00LdUdE|RML|DK|belos|lesbo|mac|faye|rets|tfe|spawny|z00k33p3r525|mtn|revott|shitbusters)$",rlsname,re.IGNORECASE):
				print "%s is flagged as non-scene. Skipping..." % rlsname
				continue
		
			if "-" not in rlsname:
				print "%s is flagged as non-scene. Skipping..." % rlsname
				continue
			else:
				if len(rlsname.rsplit("-",1)[-1]) > 15:
					print "%s is flagged as non-scene. Skipping..." % rlsname
					continue
		
			# Check to see if its already complete on site (doesn't work if -logonly)
			if options.uploadSQL:
				completed = 0
				query = "SELECT completed FROM releases WHERE rlsname = '%s'" % rlsname
				db.query(query)
				results = db.store_result().fetch_row(0,0)
				if len(results) == 1:
					completed = results[0][0]
				else:
					query = "SELECT rlsname FROM aliases WHERE aliases LIKE '%%%s%%'" % rlsname
					db.query(query)
					results = db.store_result().fetch_row(0,0)
					if len(results) == 1:
						alias = rlsname
						rlsname = results[0][0].replace("\'","")
						print "%s is an alias for %s." % (alias,rlsname)
						query = "SELECT completed FROM releases WHERE rlsname = '%s'" % rlsname
						db.query(query)
						results = db.store_result().fetch_row(0,0)
						if len(results) == 1:
							completed = results[0][0]
			
				if completed:
					print "%s already in db. Skipping..." % rlsname
					continue
			
			
		
			appendLine("rlsname",rlsname)
			appendLine("grp",grp)
		
			source = getSource(rlsname)
	
			codec = getCodec(rlsname)
			
			appendLine("source",source)
			appendLine("vcodec",codec)
			
			# Get NFOs
			#nfos = glob.glob("%s/*.nfo" % rlsname)
			nfos = []
			for root,dirs,files in os.walk(rlsname):
				for f in files:
					if f[-3:].lower() == 'nfo':
						nfos.append(root+slash+f)
		
						if len(nfos) > 0:
							nfoList = []
							imdbIDs = []
							newNfos = []
							for n in nfos:
								newNfos.append(n.replace(slash,"/"))
								fpnfo = open(n,"rb")
								nfo = fpnfo.read()
								fpnfo.close()
								nfoList.append(base64.b64encode(nfo))
								try:
									imdbLink = re.search("imdb.com\/title(\/tt|\?)([0-9]{7})",nfo.replace("\x00","").replace("\x88","").lower()).groups()[-1]
									#print "Found it! %s" % imdbLink
									imdbIDs.append(imdbLink)
								except:
									imdbIDs.append("NONE")
									print "Couldn't find iMDB link in nfo."

								appendLine("nfos","|".join(nfoList))
								appendLine("imdbIDs","|".join(imdbIDs))
							appendLine("nfo_filenames","|".join(newNfos))

						else:
							appendLine("nfo_filenames","NONE")
							appendLine("nfos","NONE")
							appendLine("imdbIDs","NONE")	
						
			fc = 0
			rarSize = 0
			rarFileName = ""
			for root,dirs,files in os.walk(rlsname):
				for f in files:
					if re.search("\.(rar|r[0-9]{1,2}|[0-9]{3})$",f,re.IGNORECASE):
						parent = root.rsplit(slash,1)[-1]
						if re.search("cd[1-9]|extra|%s" % rlsname,parent,re.IGNORECASE) or not re.search("sub|vobsub|sample|fix",parent,re.IGNORECASE):
							fc += 1
							if re.search("\.(part0{0,3}1\.rar|rar|001)$",f,re.IGNORECASE):
								if re.search("\.(part([0-9]{1,3})\.rar)$",f,re.IGNORECASE):
									reggroups = re.search("\.(part([0-9]{1,3})\.rar)$",f,re.IGNORECASE).groups()
									ext = reggroups[0]
									num = reggroups[-1]
									f = f.split(ext)[0]+"part"+"1".zfill(len(num))+".rar"
								rarFileName = root+slash+f
								#print rarFileName
								try:
									if os.stat(rarFileName)[6] > rarSize:
										rarSize = os.stat(rarFileName)[6]
										rarFileName = root+slash+f
								except:
									pass
		
			if fc == 0:
				fc = "N/A"
			if rarSize == 0:
				rarSize = "N/A"
			
			appendLine("fc",str(fc))
			appendLine("rarsize",rarSize)
		
			# get total size of release (and find avi or mkv for parsing)
			totalSize = 0
			videoFile = 0
			haveVideoFile = 0
		
			"""if glob.glob(rlsname.replace("[","\\[").replace("]","\\]")+slash+"*.mkv"):
				videoFile = path+slash+glob.glob(rlsname+slash+"*.mkv")[0]
				videoFileName = glob.glob(rlsname+slash+"*.mkv")[0].replace(slash,"/")
				haveVideoFile = 1
			"""
			for root,dirs,files in os.walk(rlsname):
				for f in files:
					try:
						totalSize += os.stat(root+slash+f)[6]
					except WindowsError:
						if rarSize != "N/A":
							totalSize += rarSize
						else:
							pass
					if not haveVideoFile:
						if f[-3:] in ['mkv','avi']:
							videoFile = path+slash+root+slash+f
							videoFileName = (root+slash+f).replace(slash,"/")
							haveVideoFile = 1
		
			totalSize = totalSize / 1000.00 / 1000.00
			appendLine("totalsize",totalSize)
		

			if videoFile:
				os.chdir(origcwd)
				fpvid = open(videoFile,"rb")
				data = fpvid.read(102400)
				fpvid.close()
				tempVideoFile = origcwd+slash+videoFile.rsplit(slash,1)[-1].rsplit(".",1)[0]+"-temp."+videoFile.rsplit(".")[-1]
				fpvid = open(tempVideoFile,"wb")
				fpvid.write(data)
				fpvid.close()
				resolution,framerate,acodec = getMetaData(tempVideoFile,origcwd)
				os.chdir(path)
				os.remove(tempVideoFile)
			
			else:
				videoFileName = "N/A"
				resolution = "N/A"
				acodec = "N/A"
				framerate = "N/A"
				if rarFileName:
					if os.name == "nt":
						rarcmd = "UnRAR.exe"
					else:
						rarcmd = "unrar"
					copyTo = origcwd+slash+rarFileName.strip(slash).rsplit(slash)[-1]
					shutil.copy(rarFileName,copyTo)
				
					cwd = os.getcwd()
					os.chdir(origcwd)
					filename = rarFileName.strip(slash).rsplit(slash)[-1]
					print "Couldn't find sample, unraring %s to get metadata." % filename
					before = glob.glob("*")
					cmd = "%s e -kb %s" % (rarcmd,filename)
					unrar = Popen(cmd,shell=True,stdout=subprocess.PIPE)
					start = time.time()
					size = 0
					while unrar.poll() != 0:
						#print "Unrar still going."
						time.sleep(3)
						after = glob.glob("*")
						if len(after) == len(before)+1:
							for a in after:
								if a not in before:
									videoFileName = a
									if videoFileName[-3:].lower() in ['avi','mkv']:
										resolution,framerate,acodec = getMetaData(videoFileName,origcwd)
										break
							if videoFileName != "N/A":
								newsize = os.stat(videoFileName)[6]
								if newsize == size:
									break
								else:
									size = newsize
							break
						elif time.time()-start >= 180:
							print "Gave up on unrar"
							if os.name == "nt":
								try:
									unrar.terminate()
							
								except WindowsError:
									pass
							else:
								if sys.version >= '2.6':
									unrar.terminate()
							break
				
					try:
						os.remove(videoFileName)
					except:
						if os.name == "nt":
							os.system("del /f %s" % videoFileName)
					
					
					os.remove(filename)
					os.chdir(cwd)

			appendLine("videofile",videoFileName)
			appendLine("resolution",resolution)
			appendLine("acodec",acodec)
			appendLine("framerate",framerate)
			print "writing line"
			print rlsname
			writeLine()
		
		os.chdir(origcwd)
	
	fp.close()
		
	if options.uploadSQL:
		uploadData()
	
	
		
if __name__ == '__main__':
	if len(sys.argv) < 2:
		print "Syntax: %s /path/to/movies/" % sys.argv[0]
	else:
		parser = optparse.OptionParser()
		parser.add_option("-s", action="store_true", dest="singleDir")
		parser.add_option("-l","--log-only",action="store_false",dest="uploadSQL",default=True)
		(options, args) = parser.parse_args()
		#print options
		#print args
		
		print "Import MovieInfo %s" % globals()["__VERSION__"]
		question = "Please your irc nick (or something you can be identified by) in case we need to contact you: "
		appendLine("__VERSION__",globals()["__VERSION__"])
		appendLine("contributor",raw_input(question))
		writeLine()
		
		main(options,args)
		print "Log written to %s. In case the direct upload of the data failed, give an operator this log. Thanks for your contribution. Exiting..." % globals()['filename']